package com.ruoyi.platform.mapper;

import com.ruoyi.platform.domain.Component;


import com.ruoyi.platform.vo.ComponentVo;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * (Component)表数据库访问层
 *
 * @author Xidaray
 * @since 2023-11-30 11:36:02
 */

public interface ComponentDao {




    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    Component queryById(Integer id);


    List<Component> queryAll();

    /**
     * 查询指定行数据
     *
     * @param component 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<Component> queryAllByLimit(@Param("component")Component component, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param component 查询条件
     * @return 总行数
     */
    long count(@Param("component")Component component);

    /**
     * 新增数据
     *
     * @param component 实例对象
     * @return 影响行数
     */
    int insert(@Param("component")Component component);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<Component> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<Component> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<Component> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<Component> entities);



    /**
     * 修改数据
     *
     * @param component 实例对象
     * @return 影响行数
     */
    int update(@Param("component") Component component);


    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(@Param("id") Integer id);

    // 检查相同category_id下的component_name是否存在
    Integer countByNameAndCategoryId(@Param("componentName") String componentName, @Param("categoryId") Integer categoryId);










}

